<app-loader *ngIf="isLoad"></app-loader>

<div class="py-20" >
	<div class="mb-16">
		<div fxFlex="">
			<span [matTooltip]="checkAddRemove ? null : 'Добавление недоступно'" >
				<button mat-flat-button
					*ngIf="!entranceTestsForm"
					(click)="addEntranceTests()"
					[disabled]="!checkAddRemove"
					color="primary"
				>
					<mat-icon svgIcon="plus"></mat-icon>
					Добавить вступительное испытание
				</button>
			</span>
		</div>
		<button mat-stroked-button color="primary" (click)="sendTestsToEpgu()"> Синхронизировать с ЕПГУ </button>
	</div>




	<mat-card class="art-card mb-20" *ngIf="entranceTestsForm">
		<form [formGroup]="entranceTestsForm">
			<div fxLayout="row" fxLayout.lt-md="column" fxLayoutGap='16px'>
				<mat-form-field appearance="fill" fxFlex="75">
					<mat-label> Тип Вступительного испытания</mat-label>
					<mat-select formControlName="id_entrance_test_type" required>
						<mat-option *ngFor="let item of cls.entrance_test_types.data " [value]="item.id">
							{{item.name}}
						</mat-option>
					</mat-select>
				</mat-form-field>
				<mat-form-field appearance="fill" fxFlex="31">
					<mat-label> UID </mat-label>
					<input matInput formControlName="uid" appNullValue>
				</mat-form-field>
			</div>
			<div fxLayout="row" fxLayout.lt-md="column" fxLayoutGap='16px'>
				<mat-form-field appearance="fill" fxFlex="15" fxFlex.lt-md="100">
					<mat-label> ЕГЭ</mat-label>
					<mat-select formControlName="is_ege"
						(valueChange)="changeEge($event)"
						required>
						<mat-option [value]="true">Да</mat-option>
						<mat-option [value]="false">Нет</mat-option>
					</mat-select>
				</mat-form-field>
				<mat-form-field *ngIf="entranceTestsForm.get('is_ege').value" appearance="fill"  fxFlex="" fxFlex.lt-md="100" >
					<mat-label> Предмет</mat-label>
					<mat-select formControlName="id_subject"
						(valueChange)="changeSubject($event)"
						[appDisableControl]="!entranceTestsForm.get('is_ege').value"
						[required]="entranceTestsForm.get('is_ege').value">
						<ngx-mat-select-search
							[placeholderLabel]="'Поиск'"
							[noEntriesFoundLabel]="'Данные не найдены'"
							[(ngModel)]="cls.subjects_ege.search"  [ngModelOptions]="{standalone: true}">
							<mat-icon ngxMatSelectSearchClear svgIcon="close"></mat-icon>
						</ngx-mat-select-search>
						<mat-option *ngFor="let item of cls.subjects_ege.data | filter: cls.subjects_ege.search"
							[value]="item.id">
							{{item.name}}
						</mat-option>
					</mat-select>
					<mat-error *ngIf="entranceTestsForm.get('id_subject').hasError('duplicate')">
						Уже создано вступительное испытание с данным предметом ЕГЭ
					</mat-error>
				</mat-form-field>

				<mat-form-field *ngIf="!entranceTestsForm.get('is_ege').value" appearance="fill" fxFlex="" fxFlex.lt-md="100">
					<mat-label> Предмет</mat-label>
					<input matInput [matAutocomplete]="auto"
						formControlName="test_name"
						[appDisableControl]="entranceTestsForm.get('is_ege').value"
						[required]="!entranceTestsForm.get('is_ege').value">
					<mat-autocomplete #auto="matAutocomplete">
						<mat-option *ngFor="let item of cls.subjects_no_ege.data | filter: entranceTestsForm.get('test_name').value || '' "
							[value]="item.name">
							{{item.name}}
						</mat-option>
					</mat-autocomplete>
					<mat-error *ngIf="entranceTestsForm.get('test_name').hasError('duplicateTestName')">
						Уже создано вступительное испытание с данным предметом
					</mat-error>
				</mat-form-field>


				<mat-form-field appearance="fill"  fxFlex="15" fxFlex.lt-md="100" >
					<mat-label> Минимальный балл</mat-label>
					<input matInput appInteger formControlName="min_score" required>
				</mat-form-field>

				<mat-form-field appearance="fill"  fxFlex="15" fxFlex.lt-md="100" >
					<mat-label> Приоритет (от 1 до 10)</mat-label>
					<input matInput appInteger maxLength="2"
						formControlName="priority" required>
					<mat-error *ngIf="entranceTestsForm.get('priority').hasError('duplicate')">
						Этот приоритет уже установлен в данной ПК
					</mat-error>
				</mat-form-field>

				<!--<button mat-button (click)="getForm()">Получить данные</button>-->


			</div>


			<div>
				<button mat-flat-button
					color="primary"
					class="mr-16"
					(click)="saveEntranceTests()"
					[disabled]="entranceTestsForm.invalid" >
					<span> Сохранить </span>
				</button>
				<button mat-stroked-button
					color="primary"
					(click)="cancel()">
					<span> Отменить </span>
				</button>

			</div>


		</form>
		<mat-card-content>

		</mat-card-content>
	</mat-card>

	<div class="art-card" *ngIf="data; else entrantsTestEmpty">
			<table mat-table
				[dataSource]="data"
				multiTemplateDataRows>
				<ng-container matColumnDef="id">
					<th mat-header-cell *matHeaderCellDef > ID </th>
					<td mat-cell *matCellDef="let row"> {{ row.id }}</td>
				</ng-container>

				<ng-container matColumnDef="testType">
					<th mat-header-cell *matHeaderCellDef > Тип вступительного испытания </th>
					<td mat-cell *matCellDef="let row"> {{ row.name_entrance_test_type }}</td>
				</ng-container>

				<ng-container matColumnDef="subject">
					<th mat-header-cell *matHeaderCellDef > Предмет </th>
					<td mat-cell *matCellDef="let row">
						<span *ngIf="row.is_ege">{{ row.name_subject }}</span>
						<span *ngIf="!row.is_ege">{{ row.test_name }}</span>
					</td>
				</ng-container>

				<ng-container matColumnDef="ege">
					<th mat-header-cell *matHeaderCellDef > Тип </th>
					<td mat-cell *matCellDef="let row"> {{ row.is_ege | yesNo: 'ЕГЭ': 'Не ЕГЭ' }}</td>
				</ng-container>

				<ng-container matColumnDef="mark">
					<th mat-header-cell *matHeaderCellDef > Мин. балл </th>
					<td mat-cell *matCellDef="let row"> {{ row.min_score }}</td>
				</ng-container>

				<ng-container matColumnDef="priority">
					<th mat-header-cell *matHeaderCellDef > Приоритет </th>
					<td mat-cell *matCellDef="let row"> {{ row.priority }}</td>
				</ng-container>

				<ng-container matColumnDef="uid">
					<th mat-header-cell *matHeaderCellDef > UID</th>
					<td mat-cell *matCellDef="let row">
						{{ row.uid || '-'}}
						<button mat-icon-button
							(click)="editUidTest(row)"
							matTooltip="Редактировать uid" >
							<mat-icon svgIcon="pencil"></mat-icon>
						</button>
					</td>
				</ng-container>

				<ng-container matColumnDef="actions">
					<th mat-header-cell *matHeaderCellDef > </th>
					<td mat-cell *matCellDef="let row; let index = dataIndex;">
						<span [matTooltip]="checkAddRemove ? null : 'Удаление недоступно'">
							<button mat-icon-button
								(click)="deleteTest(row.id, index)"
								matTooltip="Удалить"
								[disabled]="!checkAddRemove"
								color="accent">
								<mat-icon svgIcon="delete"></mat-icon>
							</button>
						</span>
						<ng-container *ngIf="!row.is_ege">
							<button mat-icon-button
								[matTooltip]="row.entrance_test_calendar?.length ?  'Показать даты ВИ' : 'Добавить даты ВИ' "
								(click)="toggleTestCalendar(index)">
								<mat-icon [svgIcon]="row.entrance_test_calendar?.length ? 'calendar-check' : 'calendar-plus' "></mat-icon>
							</button>
						</ng-container>

					</td>
				</ng-container>

				<ng-container matColumnDef="testCalendar">
					<td mat-cell *matCellDef="let row; let indexRow = dataIndex" [attr.colspan]="columnsHeader.length">
						<div class="py-20">
							<ng-container *ngTemplateOutlet="entrantTestCalendar; context:{row: row, indexRow: indexRow}"></ng-container>

						</div>
					</td>
				</ng-container>



				<ng-container matColumnDef="noRecord">
					<td mat-footer-cell *matFooterCellDef [colSpan]="columnsHeader.length" ><i>Вступительных испытаний не найдено</i></td>
				</ng-container>

				<tr mat-header-row *matHeaderRowDef="columnsHeader; sticky: false">
				</tr>
				<tr mat-row *matRowDef="let item; columns: columnsHeader"></tr>

				<tr mat-row *matRowDef="let row; columns: ['testCalendar']; when: isOpen" class="example-detail-row"></tr>

				<tr mat-footer-row *matFooterRowDef="['noRecord'] "
					[hidden]="data.length !== 0"></tr>

			</table>
	</div>

</div>
<ng-template #entrantsTestEmpty>
	<i> образовательные программы не найдены </i>
</ng-template>




<ng-template #entrantTestCalendar let-row="row" let-indexRow="indexRow">

		<div class="mb-16" fxLayout="row" fxLayoutAlign="start center">
			<h5 class="mr-20"> Даты проведения </h5>
			<span [matTooltip]="checkAddRemoveCalendar ? null : 'Добавление недоступно'">
				<button mat-stroked-button
					class="mr-20"
					(click)="addTestCalendar(row)"
					[disabled]="!checkAddRemoveCalendar" >
					Добавить
				</button>
			</span>

			<button mat-button
				color="accent"
				(click)="saveEntranceTestsCalendar(row)"
				*ngIf="row.new_entrance_test_calendar?.get('data').length"
				[disabled]="row.new_entrance_test_calendar.invalid">
				Сохранить
			</button>
		</div>


	<form [formGroup]="row.new_entrance_test_calendar">
		<table class="mat-table">
				<thead>
					<tr class="mat-header-row">
						<th class="mat-header-cell"> ID </th>
						<th class="mat-header-cell" width="25%"> Дата и время проведения </th>
						<th class="mat-header-cell" width="30%" > Место проведения </th>
						<th class="mat-header-cell" width="20%"> Макс. кол-во человек </th>
						<th class="mat-header-cell" width="20%"> UID </th>
						<th class="mat-header-cell"></th>
					</tr>
				</thead>



					<tbody formArrayName="data">
						<ng-container *ngFor="let item of row.new_entrance_test_calendar.controls['data'].controls; let index = index;">
							<tr class="mat-row" [formGroupName]="index">
								<td class="mat-cell"></td>
								<td class="mat-cell">
									<div fxLayoutGap="16px">

										<mat-form-field appearance="standard" fxFlex="" class="xl-input">
											<input matInput [matDatepicker]="picker"
												formControlName="entrance_test_date"
												placeholder="Дата проведения ВИ *"
												required>
											<mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
											<mat-datepicker #picker></mat-datepicker>
										</mat-form-field>

										<mat-form-field appearance="standard" class="s-input">
											<input matInput
												type = "time"
												formControlName="entrance_test_time"
												placeholder="Время *"
												required>
										</mat-form-field>
									</div>
								</td>
								<td class="mat-cell">
									<div>
										<mat-form-field appearance="standard" fxFlex="" class="l-input">
											<input matInput
												formControlName="exam_location"
												placeholder="Место проведения *"
												required>
										</mat-form-field>
									</div>

								</td>
								<td class="mat-cell">
									<div>
										<mat-form-field appearance="standard" fxFlex="" class="l-input">
											<input matInput
												appNullValue
												appInteger
												formControlName="count_c"
												placeholder="Макс. кол-во человек">
										</mat-form-field>
									</div>
								</td>
								<td class="mat-cell">
									<div>
										<mat-form-field appearance="standard" fxFlex="" class="l-input">
											<input matInput
												formControlName="uid"
												appNullValue
												placeholder="UID"
												maxLength="36">
										</mat-form-field>
									</div>

								</td>
								<td class="mat-cell">
									<button mat-icon-button (click)="deleteNewTestDate(row.new_entrance_test_calendar.controls['data'], index)">
										<mat-icon svgIcon="delete"></mat-icon>
									</button>
								</td>
							</tr>
						</ng-container>
					</tbody>


					<tbody>
						<ng-container *ngFor="let item of row.entrance_test_calendar; index as index">
							<tr class="mat-row">
								<td class="mat-cell"> {{item.id}} </td>
								<td class="mat-cell">
									{{ item.entrance_test_date | date: 'dd.MM.yyyy HH:mm, (zzzz)'}}
<!--										{{ '2020-07-15T18:00:00+13:00' | date: 'dd.MM.yyyy HH:mm, (zzzz)'}}-->
								</td>
								<td class="mat-cell">
									{{item.exam_location}}
								</td>
								<td class="mat-cell">
									{{item.count_c}}
								</td>
								<td class="mat-cell">
									{{item.uid || '-'}}
									<button mat-icon-button
										(click)="editUidCalendar(item)"
										matTooltip="Редактировать uid" >
										<mat-icon svgIcon="pencil"></mat-icon>
									</button>
								</td>
								<td class="mat-cell">
									<span [matTooltip]="checkAddRemoveCalendar ? null : 'Удаление недоступно'">
										<button mat-icon-button
											(click)="deleteTestDate(item, index, indexRow)"
											[disabled]="!checkAddRemoveCalendar">
											<mat-icon svgIcon="delete"> </mat-icon>
										</button>
									</span>
								</td>
							</tr>
						</ng-container>

					</tbody>

					<tbody *ngIf="!row.entrance_test_calendar.length && !row.new_entrance_test_calendar.controls['data'].controls.length">
						<tr class="mat-row">
							<td class="mat-cell" colspan="5">
								<i>Не добавлено ни одной даты</i>
							</td>
						</tr>
					</tbody>
			</table>
	</form>

</ng-template>
